Unit Glavni;

Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

Type
  TGlavniForm = Class(TForm)
    Timer1: TTimer;
    Procedure FormCreate(Sender: TObject);
    Procedure Timer1Timer(Sender: TObject);
  End;

Var GlavniForm : TGlavniForm;

Implementation

{$R *.DFM}

Uses DirectDraw;

Var Rotacija, BPP : integer;
    ddHandle      : HWND;
    DDraw         : IDirectDraw;
    ddPrimSurf    : IDirectDrawSurface;
    ddClipper     : IDirectDrawClipper;

Function RGBBoja (R,G,B:integer) : longword;
  Begin
    Result:=0;
      Case BPP of
        16     : Result:=(R shr 3) shl 11+(G shr 2) shl 5+B shr 3;
        24, 32 : Result:=R shl 16+G shl 8+B
      End
  End;

Function ObojajPravougaonik (Surface:IDirectDrawSurface;X,Y,Boja:integer) : integer;
  Var ddBltFX        : TDDBltFX;
      Tacka          : TPoint;
      DestRect       : TRect;
      Sirina, Visina : real;
    Begin
      Result:=-1;
      If ddPrimSurf=nil then
        Exit;

      // Definisanje boje pravougaonika
      With ddBltFX do
        Begin
          dwSize:=SizeOf (ddBltFX);
          dwFillColor:=Boja
        End;

      // Izacunavanje pozicije pravougaonika na ekranu
      GetClientRect (ddHandle,DestRect);
      Tacka:=Point (0,0);
      ClientToScreen (ddHandle,Tacka);
      With DestRect do
        Begin
          Sirina:=Right/64;
          Visina:=Bottom/64;
          Left:=Round (Tacka.X+X*Sirina);
          Top:=Round (Tacka.Y+Y*Visina);
          Right:=Round (Tacka.X+(X+1)*Sirina);
          Bottom:=Round (Tacka.Y+(Y+1)*Visina)
        End;

      // Popunjavanje pravougaonika bojom
      Surface.Blt (@DestRect,nil,nil,DDBLT_WAIT or DDBLT_COLORFILL,@ddBltFX)
    End;

Function Inicijalizacija : Boolean;
  Var ddSurfDesc : TDDSurfaceDesc;
    Begin
      Result:=False;

      // Kreiranje DirectDraw interfejsa 
      If Failed (DirectDrawCreate (nil,DDraw,nil)) then
        Exit;

      With DDraw do
        Begin

          // Postavljanje kooperativnog nivoa
          If Failed (SetCooperativeLevel (ddHandle,DDSCL_NORMAL)) then
            Exit;

          // Podesavanje primarne povrsine
          FillChar (ddSurfDesc,SizeOf (ddSurfDesc),0);
          With ddSurfDesc do
            Begin
              dwSize:=SizeOf (ddSurfDesc); 
              dwFlags:=DDSD_CAPS;
              ddsCaps.dwCaps:=DDSCAPS_PRIMARYSURFACE;

              // Kreiranje povrsine
              If Failed (CreateSurface (ddSurfDesc,ddPrimSurf,nil)) then
                Exit;

              // Kreiranje i postavljanje zone odsijecanja
              If Failed (CreateClipper (0,ddClipper,nil)) then
                Exit;
              If Failed (ddClipper.SetHWnd (0,ddHandle)) then
                Exit;
              If Failed (ddPrimSurf.SetClipper (ddClipper)) then
                Exit
            End
        End;

      // Inicijalizacija je uspjesno zavrsena
      Result:=True
    End;

Procedure Iscrtaj;
  Var R, G : integer;
    Begin
      For R:=0 to 63 do
        For G:=0 to 63 do
          ObojajPravougaonik (ddPrimSurf,G,R,RGBBoja ((R*2+Rotacija) mod 256,(G+Rotacija) mod 256,(63-G)*4));
      Inc (Rotacija)
    End;

Procedure TGlavniForm.FormCreate(Sender: TObject);
  Var DC : HDC;
    Begin
      DDraw:=nil;

      // Dobijanje podataka o trenutnoj dubini boja
      DC:=GetDC (0);
      BPP:=GetDeviceCaps (DC,BITSPIXEL);
      ReleaseDC (0,DC);

      ddHandle:=Handle;

      // Inicijalizacija DirectX-a
      If not Inicijalizacija then
        Begin
          ShowMessage ('Greska u inicijalizaciji DirectX-a.');
          Exit
        End;
      Rotacija:=0;

      // Start tajmera koji vodi racuna o iscrtavanju
      Timer1.Enabled:=True

    End;

Procedure TGlavniForm.Timer1Timer(Sender: TObject);
  Begin
    Iscrtaj
  End;

End.
